namespace DependencyAnalysis.DataModel
{
    public interface IDescriptor
    {
        /// <summary>
        /// Two descriptors are equal and have the same hash code, when they are of the same
        /// type and have the same Identifier.
        /// </summary>
        string Identifier { get; }

        /// <summary>
        /// A reader friendly fully qualified name of the descriptor. It is used by ToString() methods.
        /// </summary>
        string FullName { get; }

        IDescriptor Parent { get; }
    }
}