namespace DependencyAnalysis.DataModel
{
    /// <summary>
    /// Represents an instruction of the intermediate code.
    /// </summary>
    public class Instruction
    {
        /// <summary>
        /// Position in number of bytes
        /// </summary>
        public long Offset { get; set; }

        /// <summary>
        /// the type of the operand depends on the OpCode
        /// </summary>
        public object Operand { get; set; }

        /// <summary>
        /// the type of the operand depends on the OpCode
        /// </summary>
        public object OperandNew { get; set; }

        /// <summary>
        /// Specifies the operation to be performed
        /// </summary>
        public OperationCode OpCode { get; set; }
    }
}