﻿namespace DependencyAnalysis.DataModel
{
    /// <summary>
    /// State object is used for reporting the outcome of reports and verifications.
    /// </summary>
    public class State
    {
        /// <summary>
        /// A message giving additonal information on the report for the current object.
        /// </summary>
        public string Message { get; set; }

        /// <summary>
        /// A report may add a custom object to be evaluated in the callers code. 
        /// </summary>
        public object Value { get; set; }
    }
}
