﻿using DependencyAnalysis.DataModel;
using NUnit.Framework;

namespace NUnitExample
{
    [TestFixture]
    public class FindUnreferencedElementsTest : DependencyTest
    {
        [Test]
        public void AnalysisAllPrivateMembersAreUsed()
        {
            Verifier.VerifyMembersAreUsed(DescriptorBuilder.BuildModuleDescriptor(
                    typeof(DependencyAnalysis.Properties.IAssemblyIdentifier).Assembly), NodeVisibility.Private);
        }

        [Test]
        public void AnalysisAllInternalMembersAreUsed()
        {
            Verifier.VerifyMembersAreUsed(DescriptorBuilder.BuildModuleDescriptor(
                    typeof(DependencyAnalysis.Properties.IAssemblyIdentifier).Assembly), NodeVisibility.Internal);
        }

        [Test]
        public void AnalysisAllProtectedMembersAreUsed()
        {
            Verifier.VerifyMembersAreUsed(DescriptorBuilder.BuildModuleDescriptor(
                    typeof(DependencyAnalysis.Properties.IAssemblyIdentifier).Assembly), NodeVisibility.Protected);
        }
    }
}
