﻿using DependencyAnalysis.DataModel;
using Xunit;

namespace XUnitExample
{
    public class FindUnreferencedElementsTest : DependencyTest
    {
        [Fact]
        public void AnalysisAllPrivateMembersAreUsed()
        {
            Verifier.VerifyMembersAreUsed(DescriptorBuilder.BuildModuleDescriptor(
                    typeof(DependencyAnalysis.Properties.IAssemblyIdentifier).Assembly), NodeVisibility.Private);
        }

        [Fact]
        public void AnalysisAllInternalMembersAreUsed()
        {
            Verifier.VerifyMembersAreUsed(DescriptorBuilder.BuildModuleDescriptor(
                    typeof(DependencyAnalysis.Properties.IAssemblyIdentifier).Assembly), NodeVisibility.Internal);
        }

        [Fact]
        public void AnalysisAllProtectedMembersAreUsed()
        {
            Verifier.VerifyMembersAreUsed(DescriptorBuilder.BuildModuleDescriptor(
                    typeof(DependencyAnalysis.Properties.IAssemblyIdentifier).Assembly), NodeVisibility.Protected);
        }
    }
}
