﻿using DependencyAnalysis.DataModel;
using Xunit;

namespace XUnitExample
{
    public class ModuleQualityTest : DependencyTest
    {
        [Fact]
        public void NoModuleIsInZoneOfUselessness()
        {
            Verifier.VerifyThat<ModuleDescriptor>((x, state) =>
            {
                if (!x.IsPartOfProject) return true;
                var d = Setup.Metrics.DistanceFromMainSequence(x);
                if (d > 0.7)
                {
                    state.Message = string.Format("{0:0.00}", d);
                    return false;
                }
                return true;
            });
        }

        [Fact]
        public void NoModuleIsInZoneOfPain()
        {
            Verifier.VerifyThat<ModuleDescriptor>((x, state) =>
            {
                if (!x.IsPartOfProject) return true;
                var d = Setup.Metrics.DistanceFromMainSequence(x);
                if (d < -0.7)
                {
                    state.Message = string.Format("{0:0.00}", d);
                    return false;
                }
                return true;
            });
        }
    }
}
